#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1900six4xi.py">
#<abstract4xi abstract = "fires to direction six and to distance 1900"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2six4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2SIX - COORDINATE SIGNS OF SHOOT2SIX4XI: (X - ,Y + ,Z - )
# -------------------------------------------------------------------------------------------------    
global shot2six19004xi



# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False

shot2six19004xi = {
                1:'-1000x1481y-643z',
                2:'-1047x1426y-692z',
                3:'-1072x1421y-661z',
                4:'-1116x1363y-709z',
                5:'-1141x1358y-679z',
                6:'-1181x1298y-727z',
                7:'-1198x1473y-5z',
                8:'-1206x1292y-696z',
                9:'-1242x1229y-744z',
                10:'-1267x1222y-714z',
                11:'-1274x1409y-24z',
                12:'-1299x1157y-762z',
                13:'-130x724y-1751z',
                14:'-1323x1149y-732z',
                15:'-1346x1340y-43z',
                16:'-1352x1083y-779z',
                17:'-1376x1074y-749z',
                18:'-1400x1006y-796z',
                19:'-1414x1267y-62z',
                20:'-1424x996y-766z',
                21:'-1444x927y-814z',
                22:'-1468x916y-784z',
                23:'-1477x1191y-81z',
                24:'-1484x846y-831z',
                25:'-1507x834y-801z',
                26:'-1518x763y-848z',
                27:'-1537x1111y-100z',
                28:'-1548x679y-865z',
                29:'-1574x594y-882z',
                30:'-1592x1029y-119z',
                31:'-1594x508y-898z',
                32:'-1610x422y-915z',
                33:'-1621x335y-932z',
                34:'-1622x790y-861z',
                35:'-1625x76y-981z',
                36:'-1627x249y-948z',
                37:'-1628x162y-965z',
                38:'-1643x943y-138z',
                39:'-164x699y-1758z',
                40:'-167x1349y-1326z',
                41:'-1689x855y-157z',
                42:'-1729x765y-176z',
                43:'-1765x673y-195z',
                44:'-1796x579y-214z',
                45:'-1822x484y-232z',
                46:'-1842x387y-251z',
                47:'-1858x290y-270z',
                48:'-1867x192y-289z',
                49:'-1872x93y-308z',
                50:'-196x673y-1765z',
                51:'-200x1818y-511z',
                52:'-225x645y-1772z',
                53:'-235x1326y-1340z',
                54:'-251x616y-1779z',
                55:'-261x8y-1881z',
                56:'-276x586y-1786z',
                57:'-279x23y-1879z',
                58:'-294x1800y-530z',
                59:'-296x40y-1876z',
                60:'-298x555y-1792z',
                61:'-301x1298y-1353z',
                62:'-312x59y-1873z',
                63:'-317x523y-1798z',
                64:'-319x1805y-498z',
                65:'-326x80y-1869z',
                66:'-334x491y-1804z',
                67:'-339x102y-1866z',
                68:'-348x458y-1810z',
                69:'-351x126y-1862z',
                70:'-360x425y-1816z',
                71:'-361x151y-1859z',
                72:'-365x1268y-1366z',
                73:'-369x393y-1821z',
                74:'-370x178y-1855z',
                75:'-376x206y-1850z',
                76:'-376x360y-1827z',
                77:'-380x235y-1846z',
                78:'-381x328y-1832z',
                79:'-383x265y-1841z',
                80:'-383x296y-1837z',
                81:'-387x1777y-548z',
                82:'-412x1781y-516z',
                83:'-427x1234y-1379z',
                84:'-478x1749y-566z',
                85:'-485x1197y-1392z',
                86:'-503x1752y-535z',
                87:'-541x1157y-1405z',
                88:'-567x1716y-584z',
                89:'-56x769y-1736z',
                90:'-592x1718y-553z',
                91:'-595x1115y-1418z',
                92:'-645x1070y-1431z',
                93:'-654x1678y-602z',
                94:'-679x1679y-571z',
                95:'-692x1023y-1443z',
                96:'-736x973y-1455z',
                97:'-738x1636y-620z',
                98:'-764x1636y-589z',
                99:'-776x922y-1467z',
                100:'-814x870y-1479z',
                101:'-820x1590y-638z',
                102:'-845x1589y-607z',
                103:'-847x816y-1491z',
                104:'-877x760y-1503z',
                105:'-899x1539y-656z',
                106:'-904x704y-1514z',
                107:'-924x1537y-625z',
                108:'-927x647y-1526z',
                109:'-947x590y-1537z',
                110:'-94x747y-1744z',
                111:'-956x31y-1641z',
                112:'-963x532y-1548z',
                113:'-969x83y-1631z',
                114:'-975x1484y-674z',
                115:'-976x474y-1559z',
                116:'-980x136y-1621z',
                117:'-985x416y-1570z',
                118:'-987x190y-1611z',
                119:'-990x358y-1580z',
                120:'-991x245y-1601z',
                121:'-993x301y-1591z'}


#"
#/>



# -------------------------------------------------------------------------------------------------------------------
#<function4xi function = "fire1900six4xi" usage = "target function for charge2six4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------------------------
def fire1900six4xi(queue2six, consumer_channel2six, publisher_channel2six):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE1900SIX4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE1900SIX4XI -  QUEUE2SIX: ", queue2six)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE1900SIX4XI -  CONSUMER_CHANNEL2SIX: ", consumer_channel2six)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE1900SIX4XI -  PUBLISHER_CHANNEL2SIX: ", publisher_channel2six)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE1900SIX4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2six.put(shot2six19004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE1900SIX4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE1900SIX4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2SIX: ", queue2six, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE1900SIX4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2six8shot2six1900x4xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2six8shot2six1900x4xi</nack2put4xi>" 
            
        publisher_channel2six.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE1900SIX4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi()) 
            # 
        
    except:
        print(" (STEP 3C/33) OF FIRE1900SIX4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2SIX: ", publisher_channel2six, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE1900SIX4XI - RETURNING QUEUE OBJECT QUEUE2SIX: ", queue2six, " - TIME: ", time4xi())  
        # 
            
    return queue2six    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1900six4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
